-- Author: VertexFloat
-- Date: 11.12.2021
-- Version: Farming Simulator 22, 1.0.0.0
-- Copyright (C): VertexFloat, All Rights Reserved
-- Manual Combine Discharge specialization event

ManualCombineDischargeEvent = {}

ManualCombineDischargeEvent_mt = Class(ManualCombineDischargeEvent, Event)

InitEventClass(ManualCombineDischargeEvent, "ManualCombineDischargeEvent")

function ManualCombineDischargeEvent.emptyNew()
	local self = Event.new(ManualDischargeEvent_mt)
	
	return self
end

function ManualCombineDischargeEvent.new(vehicle, allowDischarge)
	local self = ManualCombineDischargeEvent.emptyNew()
	
	self.vehicle = vehicle
	self.allowDischarge = allowDischarge
	
	return self
end

function ManualCombineDischargeEvent:readStream(streamId, connection)
	self.vehicle = NetworkUtil.readNodeObject(streamId)
	
	self.allowDischarge = streamReadBool(streamId)
	
	self:run(connection)
end

function ManualCombineDischargeEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.vehicle)
	
	streamWriteBool(streamId, self.allowDischarge)
end

function ManualCombineDischargeEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(ManualCombineDischargeEvent.new(self.vehicle, self.allowDischarge), nil, connection, self.vehicle)
	end
	
	if self.vehicle ~= nil then
		self.vehicle:setDischargeCombineState(self.allowDischarge, true)
	end
end